/* memtest.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define N 4

static char *check[] =
    {
    "ok", "empty", "bad begin", "bad node", "bad end", "bad rover"
    };

int main ()
    {
    char buf[256], *p;
    void *table[N];
    int idx;
    int i, n;

    for (i = 0; i < N; ++i)
        table[i] = NULL;
    idx = 0;
    for (;;)
        {
        n = (int)sbrk (0);
        (void)printf ("sbrk = %d\n", n);
        for (i = 0; i < N; ++i)
            {
            if (i == idx) (void)putchar ('*');
            (void)printf ("%d:%d  ", i, (int)table[i]);
            }
        (void)printf ("\n? ");
        if (fgets (buf, sizeof (buf), stdin) == NULL)
            return (0);
        p = strchr (buf, '\n');
        if (p != NULL) *p = 0;
        if (buf[0] == 'q')
          return (0);
        else if (buf[0] == 'f')
            {
            (void)printf ("free\n");
            free (table[idx]); table[idx] = NULL;
            }
        else if (buf[0] == 'c')
            (void)printf ("%s\n", check[_heapset ('/')]);
        else if (buf[0] == 't')
            {
            /* provoke exception */
            char *x;
            x = (char *)0x12345678;
            ++*x;
            }
        else if (buf[0] == 0)
            idx = (idx+1)%N;
        else
            {
            i = atoi (buf);
            p = malloc (i);
            if (p == NULL)
                (void)printf ("malloc failed\n");
            else
                {
                table[idx] = p;
                (void)memset (p, '*', i);
                }
            }
        }
    }
